typedef union {
    CtkToken*         tok;
    CtkProgram*       prog;
    CtkTokenList*     toks;
    CtkStmt*          stmt;
    CtkExpr*          expr;
    CtkCaseStmt*      cass;
    CtkArrayElemExpr* pair;
    ctk_integer       ival;
    ctk_real          rval;
    char*             sval;  
} YYSTYPE;
#define	BREAK	258
#define	CASE	259
#define	CATCH	260
#define	CONTINUE	261
#define	DEFAULT	262
#define	DO	263
#define	ELSE	264
#define	FOR	265
#define	FUNCTION	266
#define	IDENT	267
#define	IF	268
#define	IMPORT	269
#define	NULLLITERAL	270
#define	PAR	271
#define	RETURN	272
#define	THROW	273
#define	TRY	274
#define	SYNCHRONIZED	275
#define	SWITCH	276
#define	WHILE	277
#define	ILITERAL	278
#define	RLITERAL	279
#define	SLITERAL	280
#define	SET_ADD	281
#define	SET_SUB	282
#define	SET_DIV	283
#define	SET_MOD	284
#define	SET_MUL	285
#define	SET_AND	286
#define	SET_OR	287
#define	SET_XOR	288
#define	SET_SHL	289
#define	SET_SHR	290
#define	LOR	291
#define	LAND	292
#define	EQ	293
#define	NE	294
#define	LE	295
#define	GE	296
#define	SHL	297
#define	SHR	298
#define	UPLUS	299
#define	UMINUS	300
#define	INC	301
#define	DEC	302


extern YYSTYPE yylval;
