#ifndef __ZE_MATRIX__
#define __ZE_MATRIX__

#include "ctalk.h"

extern "C"{
DLL_ENTRY CtkObject matCreate(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matPrint(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matGetPtr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matGetSize(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matResize(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matReshape(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matFill(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matRand(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matGetAt(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetAt(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matGetRow(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetRow(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matGetColumn(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetColumn(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matGetByIndex(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetByIndex(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matDeleteRow(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matDeleteColumn(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matInsertRow(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matInsertColumn(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matGetBlock(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetBlock(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matTranspose(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSwapRows(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSwapColumns(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matFlipRows(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matFlipColumns(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matShiftRows(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matProduct(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSort(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matUnique(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matMin(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matMax(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSum(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matConfine(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matImport(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matStringToRow(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matReadText(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matMakeJulian(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matClone(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matcos(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matacos(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matcosh(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matsin(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matasin(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matsinh(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject mattan(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matatan(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject mattanh(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matsqrt(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matexp(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matlog(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matlog10(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matceil(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matfloor(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matabs(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matpow(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matMakeIdentity(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matMakeRotateX(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matMakeRotateY(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matMakeRotateZ(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matMakeScale(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matMakeTranslate(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matAddExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSubExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matMulExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matDivExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matModExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matOrExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matAndExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matXorExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matShlExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matShrExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matEqExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matNeExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matGtExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matGeExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matLtExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matLeExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetAddExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetSubExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetMulExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetDivExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetMorExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetOrExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetAndExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetXorExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetShlExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matSetShrExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matNegExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matPreIncExpr(int nArgs, CtkObject* args);
DLL_ENTRY CtkObject matPreDecExpr(int nArgs, CtkObject* args);
}

#endif