#ifndef __SCANNER_H__
#define __SCANNER_H__

#include "ctalk.h"

#define GET_BUF_SIZE 1024

class DLL_ENTRY CtkScanner { // Modified by Jiye Zeng
    FILE* yyfile;
    char  yybuf[GET_BUF_SIZE+1];
    char* yyptr;

   public:
    int   yyline;

    void  reset(FILE* f);
    int   get();

    void  error(char const* msg);

    static CtkScanner instance;
};

#define TOKEN_HASH_TABLE_SIZE 13135

struct CtkToken;

class DLL_ENTRY CtkSymbolTable { // Modified by Jiye Zeng
    CtkToken* tokenHashTable[TOKEN_HASH_TABLE_SIZE];
    int       nSymbols;

   public:
    CtkToken* add(char const* name, int tag);

    static CtkSymbolTable instance;

    CtkSymbolTable();
    ~CtkSymbolTable();
};

#endif
